Function GetHtml(ByVal URL, ByVal Charset, ByVal TempFile, ByVal MinUpdateTime)
	Dim fs, file, stream

	Set fs = CreateObject("Scripting.FileSystemObject")

	If TempFile <> "" Then TempFile = fs.GetSpecialFolder(2) & "\" & TempFile

	If TempFile <> "" And fs.FileExists(TempFile) Then
		Set file = fs.GetFile(TempFile)
		If (MinUpdateTime >= 0) And (DateDiff("n", file.DateLastModified, Now()) > MinUpdateTime) Then
			GetHtml = FetchHtml(URL, Charset)
			Call WriteFile(TempFile, GetHtml)
		Else
			Set stream = fs.OpenTextFile(TempFile, 1)
			GetHtml = stream.ReadAll
			stream.Close
			Set stream = Nothing
		End If
		Set file = Nothing
	Else
		GetHtml = FetchHtml(URL, Charset)
		Call WriteFile(TempFile, GetHtml)
	End If
	Set fs = Nothing
End Function

'_CAbv̌o
Function RASCheck()
	Dim oRas

	On Error Resume Next
	Set oRAS = WScript.CreateObject("WSHRas.Ras")
	If Err.Number <> 0 Then
		RASCheck = True
		Exit Function
	End If
	On Error Goto 0

	RASCheck = oRAS.RASStatus()
End Function

'ۂHtmlɍs֐
Function FetchHtml(ByVal URL, ByVal Charset)
	Dim MainAgent, SubAgent
	Dim shell, fso

	Set shell=WScript.CreateObject("WScript.Shell")
	MainAgent=shell.RegRead("HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\User Agent")	' UA
	Set shell=Nothing
	SubAgent= "Samurize Client Script http://www.samurize.com/"	' Substitute User-Agent

	Set fso = CreateObject("Scripting.FileSystemObject")

	'_CAbvڑĂ邩`FbN
	If Not RASCheck() Then Exit Function

	Dim xmlhttp
	On Error Resume Next
	Set xmlhttp = CreateObject("MSXML2.ServerXMLHTTP")
	If Err <> 0 Then
		Err.Clear
		Set xmlhttp = CreateObject("Microsoft.XMLHTTP")
	End If
	On Error Goto 0
	Call xmlhttp.Open("GET", URL, False)
	Call xmlhttp.SetRequestHeader("User-Agent", MainAgent)
	Call xmlhttp.SetRequestHeader("Sub-User-Agent", SubAgent)
	Call xmlhttp.Send()
	If Err <> 0 Then Exit Function

	Dim FileName1, FileName2
	FileName1 = fso.GetSpecialFolder(2) & "\" & "response.txt"
	FileName1 = "test.euc.txt"
	FileName2 = fso.GetSpecialFolder(2) & "\" & "response2.txt"

	Dim ts
	Set ts=fso.CreateTextFile(FileName1,true,true)
	ts.Write xmlhttp.ResponseBody
	ts.close
	Set ts = Nothing
	Set xmlhttp = Nothing

	Dim TempFile1, TempFile2
	Set TempFile1=CreateObject("ADODB.Stream")
	Set Tempfile2=CreateObject("ADODB.Stream")
	TempFile1.Open
	TempFile2.Open
	TempFile1.Charset = CharSet
	TempFile2.Charset = "Shift_JIS"
	TempFile1.LoadFromFile FileName1
	TempFile1.CopyTo TempFile2
	TempFile2.SaveToFile FileName2,2
	TempFile1.Close
	TempFile2.Close
	Set stream = fso.OpenTextFile(FileName2, 1)
	FetchHtml=stream.ReadAll
	stream.Close
	Set stream = Nothing

'	fso.GetFile(FileName1).Delete
	fso.GetFile(FileName2).Delete

	Set fso = Nothing
End Function

Function OutputData(ByVal formatData, data)
	Dim key, buf, re, matches, prematch, match, size, w

	Set re = New RegExp
	re.Global = True
	re.Pattern = "#[^#]+(|\|-?[0-9]+)#"
	Set matches = re.Execute(formatData)

	Set prematch = Nothing
	For Each match In matches
		If prematch Is Nothing Then
			buf = buf & Left(formatData, match.FirstIndex)
		Else
			buf = buf & Mid(formatData, prematch.FirstIndex + prematch.Length + 1, match.FirstIndex - (prematch.FirstIndex + prematch.Length))
		End If

		w = Mid(match.value, 2, Len(match.value) - 2)
		re.Pattern = "\|-?[0-9]+$"
		key = re.Replace(w, "")
		size = Replace(w, key, "")
		If size <> "" Then
			size = CLng(Mid(size, 2))
			If size > 0 Then
				buf = buf & LeftB_sjis(data(key), size)
			Else
				buf = buf & RightB_sjis(data(key), Abs(size))
			End If
		Else
			buf = buf & data(key)
		End If

		Set prematch = match
	Next
	buf = buf & Mid(formatData, prematch.FirstIndex + prematch.Length + 1)
	Set matches = Nothing
	Set re = Nothing
	OutputData = buf
End Function

Function OutputDebug(data)
	Dim output, i, keys

	output = ""
	keys = data.Keys
	For i = LBound(keys) To UBound(keys)
		output = output & keys(i) & "=" & data(keys(i)) & vbCrLf
	Next
	OutputDebug = output
End Function

' WriteFile - should be called periodically to update data
Sub WriteFile(ByVal FileName, ByVal output)
	Dim fs, f

	Set fs = CreateObject("Scripting.FileSystemObject")
	Set f = fs.CreateTextFile(FileName, true)
	Call f.Write(output)
	Call f.Close
	Set f = Nothing
	Set fs = Nothing
End Sub

Function LeftB_sjis(ByVal str, ByVal length)
	Dim i, l, buf, c
	l = 0
	buf = ""
	For i = 1 To Len(str)
		c = Mid(str, i, 1)
		If (Asc(c) And &HFF00) = 0 Then
			l = l + 1
		Else
			l = l + 2
		End If
		If length < l Then
			Exit For
		End If
		buf = buf & c
	Next
	For i = LenB_sjis(buf) + 1 To length
		buf = buf & " "
	Next
	LeftB_sjis = buf
End Function

Function RightB_sjis(ByVal str, ByVal length)
	Dim i, l, buf, c
	l = 0
	buf = ""
	For i = Len(str) To 1 Step -1
		c = Mid(str, i, 1)
		If (Asc(c) And &HFF00) = 0 Then
			l = l + 1
		Else
			l = l + 2
		End If
		If length < l Then
			Exit For
		End If
		buf = c & buf
	Next
	For i = LenB_sjis(buf) + 1 To length
		buf = " " & buf
	Next
	RightB_sjis = buf
End Function

'Shift_JISƂăoCg擾
Function LenB_sjis(ByVal str)
    Dim i, l, c
    l = 0
    For i = 1 To Len(str)
        c = Mid(str, i, 1)
        If (Asc(c) And &HFF00) = 0 Then
            l = l + 1
        Else
            l = l + 2
        End If
    Next
    LenB_sjis = l
End Function


'Sp𔼊pɕϊ
Function ZenToHan(Str)
	For i = 1 To Len(Str)
		char = Mid(Str, i, 1)
		code = AscW(char)
		If code >= -255 And code <= -162 Then char = ChrW(code + 288)
		ZenToHan = ZenToHan & char
	Next
End Function

'TextLeftStrRightStrɈ͂܂ꂽ𔲂oAPosRightStřɐi߂
'ȂꍇDefaultStrԂ
Function FindFromText(ByRef Pos, ByVal Text, ByVal LeftStr, ByVal RightStr, ByVal DefaultStr)
	lpos = InStr(Pos, Text, LeftStr)
	If lpos > 0 Then
		lpos = lpos + Len(LeftStr)
		rpos = InStr(lpos, Text, RightStr)
		If rpos > 0 Then
			FindFromText = Mid(Text, lpos, rpos - lpos)
			Pos = rpos + Len(RightStr)
		Else
			FindFromText = DefaultStr
		End If
	Else
		FindFromText = DefaultStr
	End If
End Function


'******************************************************************************
'*** XV
'******************************************************************************
' 2003/01/22 FetchHtmlEUC-JPɑΉ()
' 2003/01/08 GetHTMLMinUpdateTimeɃ}CiXw肳ĂɃLbVt@C悤ɂB
' 2002/12/28 ɃTCYw肷ƂɁAI[o[Ă؂悤ɂB
' 2002/12/26 ɃTCYw肷邱Ƃo悤ɂB
' 2002/12/09 exec.wsfΉłƂč쐬B

